<!-- Please do not edit this file. Edit the `blah` field in the `package.json` instead. If in doubt, open an issue. -->


















# clp

 [![Support me on Patreon][badge_patreon]][patreon] [![Buy me a book][badge_amazon]][amazon] [![PayPal][badge_paypal_donate]][paypal-donations] [![Ask me anything](https://img.shields.io/badge/ask%20me-anything-1abc9c.svg)](https://github.com/IonicaBizau/ama) [![Travis](https://img.shields.io/travis/IonicaBizau/clp.svg)](https://travis-ci.org/IonicaBizau/clp/) [![Version](https://img.shields.io/npm/v/clp.svg)](https://www.npmjs.com/package/clp) [![Downloads](https://img.shields.io/npm/dt/clp.svg)](https://www.npmjs.com/package/clp) [![Get help on Codementor](https://cdn.codementor.io/badges/get_help_github.svg)](https://www.codementor.io/johnnyb?utm_source=github&utm_medium=button&utm_term=johnnyb&utm_campaign=github)

<a href="https://www.buymeacoffee.com/H96WwChMy" target="_blank"><img src="https://www.buymeacoffee.com/assets/img/custom_images/yellow_img.png" alt="Buy Me A Coffee"></a>







> A tiny and fast command line arguments parser.






## :rocket: Migration from `3.x.x` to `4.x.x`


As of `4.0.0` the scope of this package will be to simply parse

arguments. Use [**`tilda`**](https://github.com/IonicaBizau/tilda)

for a high-level interface for building cli tools.













## :cloud: Installation

```sh
# Using npm
npm install --save clp

# Using yarn
yarn add clp
```













## :clipboard: Example



```js
#!/usr/bin/env node

const clp = require("clp");

console.log(clp(["grep", "-ri", "foo"]));
// { _: [ 'grep' ], r: true, i: 'foo' }

console.log(clp(["--name", "Johnny", "-a", "20", "--location", "Earth", "--no-student"]));
// { _: [], name: 'Johnny', a: 20, location: 'Earth', student: false }
```











## :question: Get Help

There are few ways to get help:



 1. Please [post questions on Stack Overflow](https://stackoverflow.com/questions/ask). You can open issues with questions, as long you add a link to your Stack Overflow question.
 2. For bug reports and feature requests, open issues. :bug:
 3. For direct and quick help, you can [use Codementor](https://www.codementor.io/johnnyb). :rocket:





## :memo: Documentation


### `clp(args)`
Parses the cli arguments.

#### Params

- **Array** `args`: The arguments to parse (default: the process arguments).

#### Return
- **Object** An object containing the parsed arguments.














## :yum: How to contribute
Have an idea? Found a bug? See [how to contribute][contributing].


## :sparkling_heart: Support my projects
I open-source almost everything I can, and I try to reply to everyone needing help using these projects. Obviously,
this takes time. You can integrate and use these projects in your applications *for free*! You can even change the source code and redistribute (even resell it).

However, if you get some profit from this or just want to encourage me to continue creating stuff, there are few ways you can do it:


 - Starring and sharing the projects you like :rocket:
 - [![Buy me a book][badge_amazon]][amazon]—I love books! I will remember you after years if you buy me one. :grin: :book:
 - [![PayPal][badge_paypal]][paypal-donations]—You can make one-time donations via PayPal. I'll probably buy a ~~coffee~~ tea. :tea:
 - [![Support me on Patreon][badge_patreon]][patreon]—Set up a recurring monthly donation and you will get interesting news about what I'm doing (things that I don't share with everyone).
 - **Bitcoin**—You can send me bitcoins at this address (or scanning the code below): `1P9BRsmazNQcuyTxEqveUsnf5CERdq35V6`

    ![](https://i.imgur.com/z6OQI95.png)


Thanks! :heart:









## :cake: Thanks
This package is heavily based on [`minimist`](https://github.com/substack/minimist). :sparkles:








## :dizzy: Where is this library used?
If you are using this library in one of your projects, add it in this list. :sparkles:

 - `tilda`
 - `diable`
 - `a-csv`
 - `engine-tools`
 - `ghcal`
 - `name-it`
 - `namy`
 - `no-one-left-behind`
 - `wrabbit`
 - `arc-asm`
 - `gh-notifier`
 - `emojer-cli`
 - `github-emojify`
 - `github-labeller`
 - `image-to-ascii-cli`
 - `git-stats-importer`
 - `github-stats`
 - `kindly-license`
 - `npmreserve`
 - `namly`
 - `tithe`
 - `ssh-remote`
 - `rucksack.js`
 - `tinyreq-cli`
 - `cdnjs-importer`
 - `electron-comrade`
 - `@isysd/gpm`
 - `ssb-chat`
 - `gpm`
 - `photon-browser`
 - `3abn`
 - `birthday`
 - `git-issues`











## :scroll: License

[MIT][license] © [Ionică Bizău][website]






[license]: /LICENSE
[website]: https://ionicabizau.net
[contributing]: /CONTRIBUTING.md
[docs]: /DOCUMENTATION.md
[badge_patreon]: https://ionicabizau.github.io/badges/patreon.svg
[badge_amazon]: https://ionicabizau.github.io/badges/amazon.svg
[badge_paypal]: https://ionicabizau.github.io/badges/paypal.svg
[badge_paypal_donate]: https://ionicabizau.github.io/badges/paypal_donate.svg
[patreon]: https://www.patreon.com/ionicabizau
[amazon]: http://amzn.eu/hRo9sIZ
[paypal-donations]: https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=RVXDDLKKLQRJW
