<!---------------------------------------------------------------------------->
<!-- STOP, LOOK & LISTEN!                                                   -->
<!-- ====================                                                   -->
<!-- Do NOT edit this file directly since it's generated from a template    -->
<!-- file, using https://github.com/IonicaBizau/node-blah                   -->
<!--                                                                        -->
<!-- If you found a typo in documentation, fix it in the source files       -->
<!-- (`lib/*.js`) and make a pull request.                                  -->
<!--                                                                        -->
<!-- If you have any other ideas, open an issue.                            -->
<!--                                                                        -->
<!-- Please consider reading the contribution steps (CONTRIBUTING.md).      -->
<!-- * * * Thanks! * * *                                                    -->
<!---------------------------------------------------------------------------->

![couleurs](http://i.imgur.com/W3rh7oh.png)

# couleurs [![Donate now][donate-now]][paypal-donations]

Add some color and styles to your Node.JS strings.

![couleurs](http://i.imgur.com/M1D9mxT.png)

## Installation

```sh
$ npm i couleurs
```

## Example

```js
// Dependencies
var Couleurs = require("couleurs")
  , FlatColors = require("flat-colors")
  ;

// Basic usage using a random flat color
var colored = new Couleurs("Hello World").fg(FlatColors());
console.log(colored.toString());

// Other ways to color the strings
console.log(Couleurs.fg("Red", [255, 0, 0]));
console.log(Couleurs("Red foreground", [255, 0, 0]));
console.log(Couleurs.fg("Yellow", 255, 255, 0));
console.log(Couleurs.fg("Blue", "#2980b9"));
console.log(Couleurs.bg("Blue Background", "#2980b9"));
console.log(Couleurs("Blue & Underline").fg("#2980b9").bold().underline().toString());

console.log(Couleurs.bold("Bold"));
console.log(Couleurs.italic("Italic"));

// Modify prototype
Couleurs.proto();

console.log("Underline".underline());
console.log("Inverse".inverse());
console.log("Strikethrough".strike());

console.log("All combined"
    .fg("#d35400")
    .bold()
    .italic()
    .underline()
    .inverse()
    .strike()
);

```

## Documentation

### `Couleurs(setStringProto, fg)`

#### Params
- **Boolean** `setStringProto`: If `true`, the prototype of String class will be modified.
- **String|Array** `fg`: An optional foreground color.

#### Return
- **String|Object** The colored string if the `fg` argument was provided or an object containing the following methods:

 - `proto`
 - `toString`
 - `fg`
 - `bg`
 - `bold`
 - `italic`
 - `underline`
 - `inverse`
 - `strike`

### `hexToRgb(hex)`
Couleurs.hexToRgb
Converts a hex color code to rgb

#### Params
- **String** `hex`: The hex color value.

#### Return
- **Array** An array containing `r`, `g`, `b` values. If the input is invalid, `null` will be returned.

### `fg(str, r, g, b)`
Sets the foreground color.

Example:

```js
console.log(Couleurs.fg("some text", "#e74c3c"));
console.log(Couleurs("some text").fg("#e74c3c").toString());
```

#### Params
- **String** `str`: The input string.
- **String|Array|Number** `r`: If number, it will be the red value from RGB. If
  array, it should be an array of three numbers representing RGB values. If
  String, it will be interpreted as HEX color.
- **Number** `g`: Green value
- **Number** `b`: Blue value

### `bg(str, r, g, b)`
Sets the background color.

Example:

```js
console.log(Couleurs.bg("some text", "#e74c3c"));
console.log(Couleurs("some text").bg("#e74c3c").toString());
```

#### Params
- **String** `str`: The input string.
- **String|Array|Number** `r`: If number, it will be the red value from RGB. If
  array, it should be an array of three numbers representing RGB values. If
  String, it will be interpreted as HEX color.
- **Number** `g`: Green value
- **Number** `b`: Blue value

### `strike(str)`
Strikes the input string.

Example:

```js
console.log(Couleurs.strike("some text"));
console.log(Couleurs("some text").strike().toString());
```

#### Params
- **String** `str`: The input string.

### `bold(str)`
Makes the text bold.

Example:

```js
console.log(Couleurs.bold("some text"));
console.log(Couleurs("some text").bold().toString());
```

#### Params
- **String** `str`: The input string.

### `italic(str)`
Makes the text italic.

Example:

```js
console.log(Couleurs.italic("some text"));
console.log(Couleurs("some text").italic().toString());
```

#### Params
- **String** `str`: The input string.

### `underline(str)`
Makes the text underline.

Example:

```js
console.log(Couleurs.underline("some text"));
console.log(Couleurs("some text").underline().toString());
```

#### Params
- **String** `str`: The input string.

### `inverse(str)`
Inverses the input text.

Example:

```js
console.log(Couleurs.inverse("some text"));
console.log(Couleurs("some text").inverse().toString());
```

#### Params
- **String** `str`: The input string.

## How to contribute
Have an idea? Found a bug? See [how to contribute][contributing].

## License
[KINDLY][license] © [Ionică Bizău][website]–The [LICENSE](/LICENSE) file contains
a copy of the license.

[license]: http://ionicabizau.github.io/kindly-license/?author=Ionic%C4%83%20Biz%C4%83u%20%3Cbizauionica@gmail.com%3E&year=2015
[contributing]: /CONTRIBUTING.md
[website]: http://ionicabizau.net
[docs]: /DOCUMENTATION.md
[paypal-donations]: https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=MG98D7NPFZ3MG
[donate-now]: http://i.imgur.com/jioicaN.png