<!-- Please do not edit this file. Edit the `blah` field in the `package.json` instead. If in doubt, open an issue. -->


















# promptify

 [![Support me on Patreon][badge_patreon]][patreon] [![Buy me a book][badge_amazon]][amazon] [![PayPal][badge_paypal_donate]][paypal-donations] [![Ask me anything](https://img.shields.io/badge/ask%20me-anything-1abc9c.svg)](https://github.com/IonicaBizau/ama) [![Version](https://img.shields.io/npm/v/promptify.svg)](https://www.npmjs.com/package/promptify) [![Downloads](https://img.shields.io/npm/dt/promptify.svg)](https://www.npmjs.com/package/promptify) [![Get help on Codementor](https://cdn.codementor.io/badges/get_help_github.svg)](https://www.codementor.io/johnnyb?utm_source=github&utm_medium=button&utm_term=johnnyb&utm_campaign=github)

<a href="https://www.buymeacoffee.com/H96WwChMy" target="_blank"><img src="https://www.buymeacoffee.com/assets/img/custom_images/yellow_img.png" alt="Buy Me A Coffee"></a>







> An easy-to-use prompt for Node.js.

















## :cloud: Installation

```sh
# Using npm
npm install --save promptify

# Using yarn
yarn add promptify
```













## :clipboard: Example



```js
const promptify = require("promptify");

let name = promptify("Enter your name");
console.log(`Hey, ${name}!`);

let pass = promptify("Enter your password", {
    char: "*"
});
console.log(`You entered: ${pass}`);
```











## :question: Get Help

There are few ways to get help:



 1. Please [post questions on Stack Overflow](https://stackoverflow.com/questions/ask). You can open issues with questions, as long you add a link to your Stack Overflow question.
 2. For bug reports and feature requests, open issues. :bug:
 3. For direct and quick help, you can [use Codementor](https://www.codementor.io/johnnyb). :rocket:





## :memo: Documentation


### `Promptify(conf)`
Creates a new `Promptify`. In most of the cases,
there will be one such instance per process.

#### Params

- **Object** `conf`: The `Promptify` config:

#### Return
- **Promptify** The `Promptify` instance.

### `sync(message, defMsg, options)`
Synchronous version of the prompt.

#### Params

- **String** `message`: The message do display.
- **String** `defMsg`: The default value.
- **Object** `options`: An object containing the following fields:
   - `char` (String): The character to display when writing something. For
      example, if it's `*`, the text characters will be replaced with `*`.
   - `delimiter` (String): The delimiter between message and the value (default: `": "`).

#### Return
- **String** The result.

### `promptify()`
Prompt a message to the user. The arguments are passed to the `sync` method.














## :yum: How to contribute
Have an idea? Found a bug? See [how to contribute][contributing].


## :sparkling_heart: Support my projects
I open-source almost everything I can, and I try to reply to everyone needing help using these projects. Obviously,
this takes time. You can integrate and use these projects in your applications *for free*! You can even change the source code and redistribute (even resell it).

However, if you get some profit from this or just want to encourage me to continue creating stuff, there are few ways you can do it:


 - Starring and sharing the projects you like :rocket:
 - [![Buy me a book][badge_amazon]][amazon]—I love books! I will remember you after years if you buy me one. :grin: :book:
 - [![PayPal][badge_paypal]][paypal-donations]—You can make one-time donations via PayPal. I'll probably buy a ~~coffee~~ tea. :tea:
 - [![Support me on Patreon][badge_patreon]][patreon]—Set up a recurring monthly donation and you will get interesting news about what I'm doing (things that I don't share with everyone).
 - **Bitcoin**—You can send me bitcoins at this address (or scanning the code below): `1P9BRsmazNQcuyTxEqveUsnf5CERdq35V6`

    ![](https://i.imgur.com/z6OQI95.png)


Thanks! :heart:









## :cake: Thanks

 - Highly inspired from [`prompt-sync`](https://github.com/0x00A/prompt-sync). Thanks! :cake:









## :dizzy: Where is this library used?
If you are using this library in one of your projects, add it in this list. :sparkles:

 - `tilda`
 - `cli-github`
 - `parrot-bot`











## :scroll: License

[MIT][license] © [Ionică Bizău][website]






[license]: /LICENSE
[website]: http://ionicabizau.net
[contributing]: /CONTRIBUTING.md
[docs]: /DOCUMENTATION.md
[badge_patreon]: https://ionicabizau.github.io/badges/patreon.svg
[badge_amazon]: https://ionicabizau.github.io/badges/amazon.svg
[badge_paypal]: https://ionicabizau.github.io/badges/paypal.svg
[badge_paypal_donate]: https://ionicabizau.github.io/badges/paypal_donate.svg
[patreon]: https://www.patreon.com/ionicabizau
[amazon]: http://amzn.eu/hRo9sIZ
[paypal-donations]: https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=RVXDDLKKLQRJW
